testbig :- test(586382774994939529734381865743687401707281126723,1000000).
testsmall :- test(10,1000000).

test(OFF,COUNT) :-  statistics(runtime, [T1| _]),  assert_facts(COUNT,OFF), statistics(runtime, [T2| _]), T3 is T2 - T1, write(T3),nl, 
                                                   check_facts(COUNT,OFF), statistics(runtime, [T4| _]),T5 is T4 - T2, write(T5),nl,    
                                                   abolish.

abolish :- statistics(runtime, [T1| _]), 
            reset_probhash,  retractall(hash(_)),
            statistics(runtime, [T2| _]), T3 is T2 - T1, write(T3),nl.

:- dynamic(hash/1).

:- use_module(probhash).

/*
assert_facts(0,_) :- !.
assert_facts(N,V) :- hash_to_atom(V,AV),assert(hash(AV)),N1 is N-1, V1 is V + 1, assert_facts(N1,V1).

check_facts(0,_) :- !.
check_facts(N,V) :- hash_to_atom(V,AV),hash(AV), N1 is N-1, V1 is V + 1, check_facts(N1,V1).
*/



assert_facts(0,_) :- !.
assert_facts(N,V) :- add_term(V,_,_),N1 is N-1, V1 is V + 1, assert_facts(N1,V1).

check_facts(0,_) :- !.
check_facts(N,V) :- add_term(V,_,Ex), Ex==false,
                    N1 is N-1, V1 is V + 1, check_facts(N1,V1).
/*                    
assert_facts(0,_).
assert_facts(N,V) :- assert(hash(V)),N1 is N-1, V1 is V + 1, assert_facts(N1,V1).

check_facts(0,_).
check_facts(N,V) :- hash(V), N1 is N-1, V1 is V + 1, check_facts(N1,V1).

assert_facts(0,_).
assert_facts(N,V) :- num_to_atom(V,AV),assert(hash(AV)),N1 is N-1, V1 is V + 1, assert_facts(N1,V1).

check_facts(0,_).
check_facts(N,V) :- num_to_atom(V,AV),hash(AV), N1 is N-1, V1 is V + 1, check_facts(N1,V1).

*/
num_to_atom(X,Atom) :- number_codes(X, _C),atom_codes(Atom,_C).

