/*
 * structures.h
 *
 *  Created on: 25.11.2009
 *      Author: borgi
 */

#ifndef STRUCTS_H_
#define STRUCTS_H_

//stores all information about a transition index of array element is ID
typedef struct transition {
	long id;
	long src;
	long dst;
	long owner;
	long flags;
	void *action;
} transition_t;

//stores all information about a visisted expression index of array element is ID
typedef struct visited_expression {
	long id;
	long owner;
	long flags;
	void *state;
} visited_expression_t;

//element for list of src and dst elements. index of array element is src-ID/dst-ID
typedef struct index_element {
	void *transition;
	void *next;
} index_element_t;

#endif /* STRUCTURES_H_ */
