#include "user_signal.h"

int main(int argc, const char *argv[]) {
  if (argc == 2) {
    long int reference = atol(argv[1]);
#if _WIN32
    UINT msg_id = RegisterWindowMessageA(message_string);
    /* printf("Windows message id: %u\n", msg_id); */
    int succeed = PostThreadMessage((DWORD) reference, msg_id, 0, 0);
    if (!succeed) {
      fprintf(stderr, "PostThreadMessage failed!\n");
    }
#else /* _WIN32 */
    kill(reference, SIGUSR1);
#endif /* _WIN32 */
    return 0;
  } else {
    fprintf(stderr,"Wrong number of arguments, usage: %s <reference id>\n",
           argv[0]);
    return 127;
  }
}
