#ifndef KEYLIST_H_INCLUDED
#define KEYLIST_H_INCLUDED

struct List {
    unsigned char pos;
    char *digest;
    struct List *next;
};

typedef struct List keyList;

int list_contains(keyList *l, char *digest);
keyList *insert(keyList *l, int depth, int digest_pos, char *digest);
keyList *create_cell(char *digest, int digest_pos);
keyList *teardown_cell(keyList *l);
int free_position(keyList *list, int pos);

#endif
