% (c) 2009-2012 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 

:- module(typing_tools,[
     is_infinite_type/1, % check if a type is infinite
     contains_infinite_type/1
  ]).

is_infinite_type(integer).
is_infinite_type(set(X)) :- is_infinite_type(X).
is_infinite_type(seq(_)).
is_infinite_type(couple(X,Y)) :- (is_infinite_type(X) -> true ; is_infinite_type(Y)).

contains_infinite_type([H|T]) :- 
  (is_infinite_type(H) -> true ; contains_infinite_type(T)).