% (c) 2009-2010 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 


% currently unused code:




% from kernel_objects


is_implementable(int(X)) :- preferences:get_preference(maxint,MAXINT),
   preferences:get_preference(minint,MININT),
   when(nonvar(X), (X=<MAXINT , X>=MININT)).
not_is_implementable(int(X)) :- preferences:get_preference(maxint,MAXINT),
   preferences:get_preference(minint,MININT),
   when(nonvar(X), (X>MAXINT ; X<MININT)).
is_implementable_max(int(X)) :- preferences:get_preference(maxint,MAXINT),
   when(nonvar(X), X=<MAXINT).
      

% tried to replace equal_sets3b by equal_sets3 December 4 2008 with remove_from_set:
equal_sets3([HX|TX],Set2) :- remove_from_set(HX,Set2,RSet2), equal_sets(TX,RSet2).

:- block remove_from_set(?,-,?).
remove_from_set(Obj,[H|T],Res) :- var(H), ground(Obj), !, H=Obj, Res=T.
remove_from_set(Obj,[H|T],Res) :- 
     equal_object(Obj,H), Res=T.
remove_from_set(Obj,[H|T],Res) :- not_equal_object(Obj,H), Res=[H|TR], remove_from_set(Obj,T,TR).




:- block check_is_a_set(-).
check_is_a_set(X) :- (is_a_set2(X) -> true ; (add_error(kernel_objects,'Type error, not a set: ',X),fail)).

:- block is_an_integer(-).
is_an_integer(X) :- is_integer(X). /* check without instantiating */

:- block check_is_integer(-).
check_is_integer(X) :-
   (is_integer(X) -> true ; (add_error(kernel_objects,'Type error, not an integer: ',X),fail)).
   
:- block try_prop_card_lt(-,?).
%try_prop_card_lt(X,Y) :- print(try_prop_card_lt(X,Y)),nl,fail.
try_prop_card_lt([],R) :- var(R),!,R=[_|_].
try_prop_card_lt([],_) :- !.
try_prop_card_lt([_|T],R) :- var(R),!,R=[_,HR|TR], try_prop_card_lt(T,[HR|TR]).
try_prop_card_lt([_|T],[_,HR|TR]) :- !, try_prop_card_lt(T,[HR|TR]).
try_prop_card_lt(_,_).

:- block try_prop_card_gt(-,?).
try_prop_card_gt([],_) :- !,fail.
try_prop_card_gt([_|T],R) :- !, try_prop_card_geq(T,R).
try_prop_card_gt(_,_).

:- block try_prop_card_geq(-,?).
try_prop_card_geq([],R) :- !,empty_set(R).
try_prop_card_geq([_|T],R) :- !, try_prop_card_geq2(R,T).
try_prop_card_geq(_,_).

:- block try_prop_card_geq2(-,?).
try_prop_card_geq2([],_) :- !.
try_prop_card_geq2([_|TR],T) :- !, try_prop_card_geq(T,TR).
try_prop_card_geq2(_,_).

:- block try_prop_card_leq(-,?).
try_prop_card_leq([],_) :- !.
try_prop_card_leq([_|T],R) :- var(R),!,R=[_|TR], try_prop_card_leq(T,TR).
try_prop_card_leq([_|T],[_|TR]) :- !, try_prop_card_leq(T,TR).
try_prop_card_leq(_,_).


% TODO: Can be removed?
:- assert_must_succeed(( kernel_objects:pred2(A,B),A=5,B==4 )).
:- assert_must_succeed(( kernel_objects:pred2(A,B),B=4,A==5 )).

pred(int(X),int(X1)) :- pred2(X,X1).
:- block pred2(-,-).
pred2(X,X1) :-
    ( ground(X) -> X1 is X-1
    ; otherwise -> X is X1+1).

% TODO: Can be removed?
:- assert_must_succeed(( kernel_objects:succ2(A,B),A=5,B==6 )).
:- assert_must_succeed(( kernel_objects:succ2(A,B),B=6,A==5 )).

succ(int(X),int(X1)) :- succ2(X,X1).
:- block succ2(-,-).
succ2(X,X1) :-
    ( ground(X) -> X1 is X+1
    ; otherwise -> X is X1-1).
    

% from bsets_clp

/*
projection1(RelationAB,RelationA) :- when(nonvar(RelationAB),proj1(RelationAB,RelationA)).
proj1([],[]).
proj1([(X,_)|T],[X|PT]) :- projection1(T,PT).
projection2(RelationAB,RelationA) :- when(nonvar(RelationAB),proj2(RelationAB,RelationA)).
proj2([],[]).
proj2([(_,X)|T],[X|PT]) :- projection2(T,PT).*/

