#include "sha.h"
#include <sicstus/sicstus.h>

static SP_term_ref buf_to_list(uint8_t *buf, size_t len);

SP_term_ref sha1(uint8_t* input, int len) {
	uint8_t digest[20];
	struct sha_ctx ctx;
	sha_init(&ctx);
	sha_update(&ctx,input,len);
	sha_final(digest,&ctx);
	return buf_to_list(digest,20);
}


SP_term_ref buf_to_list(uint8_t *buf, size_t len)
{
  SP_term_ref bList = SP_new_term_ref();
  SP_term_ref tail = SP_new_term_ref();
  SP_put_list_n_bytes(bList, tail, len, buf);
  return bList;
}

