#!/bin/bash
PROBCOMMAND=probcli


if [ $# -ne 6 ] 
then	
	echo "Usage ./parB2 <Nr. of workers> <minimum que size> <time intervall> <max number of states> <filename for statistics> <file>"
	exit -1
else 
	echo "Running ProB in Parallel (on .prob files)"	
	# dirname
	if [ -h "$0" ]
	then
	    realname=`readlink "$0"`
	    dirname=`dirname "$realname"`
	else
	    dirname=`dirname "$0"`
	fi
	
	ulimit -d unlimited
	
	echo "Directory: $dirname"

# dirname
if [ -h "$0" ]
then
    realname=`readlink "$0"`
    dirname=`dirname "$realname"`
else
    dirname=`dirname "$0"`
fi

ulimit -d unlimited

# setting the library path to find the zmq shared libraries
system=`uname`
if [ $system = "Linux" ]; then
  export LD_LIBRARY_PATH="$dirname/lib"
fi

echo "Directory: $dirname"
#cd $dirname
#ls
echo "Starting workers in parallel"
for ((  i = 0 ;  i < $1;  i++  ))
do
  "$dirname/$PROBCOMMAND" -zmq_worker &
done
shift
echo "Starting master: $dirname/$PROBCOMMAND -zmq_master " $*
time "$dirname/$PROBCOMMAND" -zmq_master2 $*
fi
