:- module(probvm_termexpansion,[]).

:- use_module(probsrc(module_information)).
:- module_info(group,plugin_vm).
:- module_info(description,'Experimental VM plugin: The term expander should speed up the interpretation by hard-wire mappings to the kernel.').
:- module_info(revision,'$Rev$').
:- module_info(lastchanged,'$LastChangedDate$').


print_clauses(Term) :-
    member(Clause,Term),
    portray_clause(Clause),fail.
print_clauses(_).

:- multifile user:term_expansion/6.
user:term_expansion(Term1, _Layout1, Ids, Term2, Layout2, [interpreter_patterns|Ids]) :-
	nonvar(Term1), nonmember(interpreter_patterns,Ids),
    Term1 = ( :- insert_interpreter_patterns ),
	findall( ( interpret(VmCode,WF) :- !, PrologCode ),
             probvm_interpreter:interpreter_pattern(VmCode,WF,PrologCode),
             Term2),
    % probvm_termexpansion:print_clauses(Term2),
    Layout2 = [].
